# Contributing

Thank you for taking the time to _want_ to contributed to CS886.
Here we outline how we can make your contribution

## Raising Issues

We are sorry if you have found any issues.
Please report the issues you have found to our issue tracker at:

https://gitlab.cis.strath.ac.uk/cwb23122/cs886-asbd/-/issues

Please only submit one issue at a time.

## Submitting changes

We welcome,
reasonable,
Pull Requests (PRs) to the course.
We retain the right to refuse PRs that go against the _spirit_ of the course, or make unnecessary changes.

Please send PRs to:

https://gitlab.cis.strath.ac.uk/cwb23122/cs886-asbd

It is important that when submitting your PR that both the commit message and description provides a clear list of what you have changed.
GitHub provides good material on what [a good PR can look like](https://docs.github.com/en/pull-requests/collaborating-with-pull-requests/getting-started/best-practices-for-pull-requests).

Please ensure that all your commits are atomic
(with one feature per commit)
and that you are familiar with the repositories conventions
(see below).

To help preserve your contribution for the long run, we request the following.

1. Commit messages are tagged with a leading topic indicator.
   For example:  `[ admin ]` or `[ typo ]`.
   Although we do not specify a indicator hierarchy please use common sense.
   We use the indicators to categorise commits, and make the contribution more informative.

2. Make sure your commit messages are clear and appropriate,
   containing sufficient information for people to understand your commit in years to come.

3. Commit messages should have the following format.

   ```
   [ topic ] A brief summary of the commit, less than 50 chars.

   A paragraph describing the change, and the impact.
   ```

4. There should be a 1-2-1 correspondence between git commit messages, and the description specified in the web interface.
   We may wish to move from gitlab at some point, and preserving history is important.

5. When closing an issues please make reference to the issue within the commit message itself.

## Conventions

We will develop conventions as we go.

1. Please use semantic line breaks when contributing text.

   https://sembr.org/

2. Code should be readable and documented.

3. Campsite rule, leave the repository better than as you found it.
