||| =============================================================================
|||
||| Introduction to Idris, the programming language
|||
||| =============================================================================
|||
||| At its core Idris is a functional programming language.
|||
||| This file demonstrates what that means, and we will do this by example by
||| look at operating over 'lists'.
|||
||| We will provide some sample code, and function type signatures.
|||
||| We will answer some questions together, but we will give you this file
||| unmodified to try outside of the lecture.
|||
||| A lengthier look at Idris is on MyPlace.
module Idris

-- =============================================================================
--
-- Let us begin with a function that returns a list of Integers.
--
-- =============================================================================

myFirstList : List Int
myFirstList = [1,2,3,4]

{- [ Marker ] ==================================================================

-- [ Question ]
--
-- Can you write a function that returns the list `[1,2,3,4,5,6,7,8]`?


-- [ Question ]
--
-- Can you finish this function that checks if an integer is positive?
-- It will need to return Bool.

isPositive : (i : int) -> Bool
isPositive i = False


testIsPositive1 : isPositive 1 = True
testIsPositive1 = Refl

testIsPositive2 : isPositive (-1) = True
testIsPositive2 = Refl

testIsPositive3 : isPositive 0 = True
testIsPositive3 = Refl

-- =============================================================================
--
-- Questions on writing functions that operate on lists and integers.
--
-- =============================================================================
--
-- As a reminder, lists in Idris are defined as:
--
--

||| A reminder of list definitions:
namespace Hidden

  data List type = Nil | (::) type (Hidden.List type)

-- [ Question ]
--
-- Can you finish this function that *should* append two lists together?

myAppend : (xs : List t) -> (ys : List t) -> List t
myAppend xs ys = []

testMyAppend1 : myAppend [1,2,3,4] [5,6,7,8] = [1,2,3,4,5,6,7,8]
testMyAppend1 = Refl

-- [ Question ]
--
-- Can you finish this function that returns the first element (the head) of a list?
--
-- Hint: `Maybe`, is defined in Idris already.

namespace Hidden

  data Maybe type = Nothing | Just type


myHead : List type -> Maybe type


testMyHead0 : myHead [1,2,3,4] = Just 1
testMyHead0 = Refl

testMyHead1 : myHead [] = Nothing
testMyHead1 = Refl



-- [ Question ]
--
-- Can you finish this function that returns all but the first element of a list
-- (the tail)?

myTail : List type -> List type

testMyTail : myTail [1,2,3,4] = [2,3,4]
testMyTail = Refl

-- =============================================================================
--
-- Questions on datatypes
--
-- =============================================================================



-- [ Question ]
--
-- Can you finish this function that returns the following string?
--
-- + "Is Nothing" if `m` is `Nothing`;
-- + "Is a Value" if `m` is `Just(t)`;

myMaybeToString : (m : Maybe type)
                    -> String

testMyMaybeToString0 : myMaybeToString Nothing = "Is Nothing"
testMyMaybeToString0 = Refl

testMyMaybeToString1 : myMaybeToString (Just 1) = "Is a Value"
testMyMaybeToString1 = Refl


-- =============================================================================
--
-- Questions on printing things about lists to STDOUT.
--
-- =============================================================================

-- [ NOTE ] As these tests are impure, we will run these 'test' programs.
--
-- The test runner is at the end of this section.
--



-- [ Question ]
--
-- Can you finish this function that prints out each element in the sequence?

myShowList : Show type
          => List type
          -> IO ()


-- [ Question ]
--
-- Can you finish this function that prints out each element in the sequence,
-- and if the sequence is empty, then prints "Empty List"?

myShowList2 : Show type
           => List type
           -> IO ()

namespace Main
  main : IO ()
  main = do printLn "Testing myShowList"
            myShowList [1,2,3,4]
            myShowList []

            printLn "Testing myShowList2"
            myShowList2 [1,2,3,4]
            myShowList2 []



== [ Marker ] =============================================================== -}

-- [ EOF ]


-- [ Question ]
--
--

-- [ NOTES ]
--
--

-- =============================================================================
--
-- =============================================================================
--
--
